<!DOCTYPE html>
<html lang="en">
  <head>
    <title>NetworkManager Class Reference</title>
    <link rel="stylesheet" type="text/css" href="../css/jazzy.css" />
    <link rel="stylesheet" type="text/css" href="../css/highlight.css" />
    <meta charset='utf-8'>
    <script src="../js/jquery.min.js" defer></script>
    <script src="../js/jazzy.js" defer></script>
    
  </head>
  <body>
    <a name="//apple_ref/swift/Class/NetworkManager" class="dashAnchor"></a>
    <a title="NetworkManager Class Reference"></a>
    <header>
      <div class="content-wrapper">
        <p><a href="../index.html"> Docs</a> (90% documented)</p>
      </div>
    </header>
    <div class="content-wrapper">
      <p id="breadcrumbs">
        <a href="../index.html"> Reference</a>
        <img id="carat" src="../img/carat.png" />
        NetworkManager Class Reference
      </p>
    </div>
    <div class="content-wrapper">
      <nav class="sidebar">
        <ul class="nav-groups">
          <li class="nav-group-name">
            <a href="../Classes.html">Classes</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="../Classes/AppDelegate.html">AppDelegate</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/BackgroundController.html">BackgroundController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CoreDataManager.html">CoreDataManager</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CurrencyController.html">CurrencyController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CurrencyRate.html">CurrencyRate</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CurrencyRateManager.html">CurrencyRateManager</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CurrencyRatePack.html">CurrencyRatePack</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CurrencyRatePackParser.html">CurrencyRatePackParser</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/ExchangeController.html">ExchangeController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/ExchangeModelManager.html">ExchangeModelManager</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/FromCurrencyController.html">FromCurrencyController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/FromCurrencyPageController.html">FromCurrencyPageController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/NetworkManager.html">NetworkManager</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/NetworkManager/NetworkManagerError.html">– NetworkManagerError</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/ToCurrencyController.html">ToCurrencyController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/ToCurrencyPageController.html">ToCurrencyPageController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/UserData.html">UserData</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="../Enums.html">Enums</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="../Enums/CurrencyType.html">CurrencyType</a>
              </li>
              <li class="nav-group-task">
                <a href="../Enums/RequestResult.html">RequestResult</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="../Extensions.html">Extensions</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="../Extensions/NSManagedObject.html">NSManagedObject</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="../Functions.html">Functions</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="../Functions.html#/s:F15testApplication8debugLogFTSS4fileVs12StaticString8functionS0_4lineSi_T_">debugLog(_:file:function:line:)</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="../Protocols.html">Protocols</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="../Protocols/CurrencyControllerDelegate.html">CurrencyControllerDelegate</a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <article class="main-content">
        <section>
          <section class="section">
            <h1>NetworkManager</h1>
              <div class="declaration">
                <div class="language">
                  <pre class="highlight"><code><span class="kd">class</span> <span class="kt">NetworkManager</span></code></pre>

                </div>
              </div>
            <p>NetworkManager makes HTTP-request to external server.</p>

          </section>
          <section class="section task-group-section">
            <div class="task-group">
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:OC15testApplication14NetworkManager19NetworkManagerError"></a>
                    <a name="//apple_ref/swift/Enum/NetworkManagerError" class="dashAnchor"></a>
                    <a class="token" href="#/s:OC15testApplication14NetworkManager19NetworkManagerError">NetworkManagerError</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Error generated by NetworkManager.</p>

                        <a href="../Classes/NetworkManager/NetworkManagerError.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">enum</span> <span class="kt">NetworkManagerError</span><span class="p">:</span> <span class="kt">Error</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:C15testApplication14NetworkManager27PostExchangeOperationResult"></a>
                    <a name="//apple_ref/swift/Alias/PostExchangeOperationResult" class="dashAnchor"></a>
                    <a class="token" href="#/s:C15testApplication14NetworkManager27PostExchangeOperationResult">PostExchangeOperationResult</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>result of postExchangeOperation(fromCurrency:fromValue:toCurrency:toValue:completion:)</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">typealias</span> <span class="kt">PostExchangeOperationResult</span> <span class="o">=</span> <span class="kt"><a href="../Enums/RequestResult.html">RequestResult</a></span><span class="o">&lt;</span><span class="kt">Bool</span><span class="p">,</span><span class="kt">NetworkManager</span><span class="o">.</span><span class="kt"><a href="../Classes/NetworkManager/NetworkManagerError.html">NetworkManagerError</a></span><span class="o">&gt;</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:C15testApplication14NetworkManager17RateRequestResult"></a>
                    <a name="//apple_ref/swift/Alias/RateRequestResult" class="dashAnchor"></a>
                    <a class="token" href="#/s:C15testApplication14NetworkManager17RateRequestResult">RateRequestResult</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>result of getCurrencyRatesXML(:) - request</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">typealias</span> <span class="kt">RateRequestResult</span> <span class="o">=</span> <span class="kt"><a href="../Enums/RequestResult.html">RequestResult</a></span><span class="o">&lt;</span><span class="kt">Data</span><span class="p">,</span><span class="kt">NetworkManager</span><span class="o">.</span><span class="kt"><a href="../Classes/NetworkManager/NetworkManagerError.html">NetworkManagerError</a></span><span class="o">&gt;</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:ZFC15testApplication14NetworkManager19getCurrencyRatesXMLFT10completionGSqFGOS_13RequestResultV10Foundation4DataOS0_19NetworkManagerError_T___T_"></a>
                    <a name="//apple_ref/swift/Method/getCurrencyRatesXML(completion:)" class="dashAnchor"></a>
                    <a class="token" href="#/s:ZFC15testApplication14NetworkManager19getCurrencyRatesXMLFT10completionGSqFGOS_13RequestResultV10Foundation4DataOS0_19NetworkManagerError_T___T_">getCurrencyRatesXML(completion:)</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Makes request for new data about currency rates.
- parameter completion: completion block.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">class</span> <span class="kd">func</span> <span class="nf">getCurrencyRatesXML</span><span class="p">(</span><span class="nv">completion</span><span class="p">:</span> <span class="p">((</span><span class="kt"><a href="../Classes/NetworkManager.html#/s:C15testApplication14NetworkManager17RateRequestResult">RateRequestResult</a></span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kt">Void</span><span class="p">)?</span> <span class="o">=</span> <span class="kc">nil</span><span class="p">)</span></code></pre>

                        </div>
                      </div>
                      <div>
                        <h4>Parameters</h4>
                        <table class="graybox">
                          <tbody>
                            <tr>
                              <td>
                                <code>
                                <em>completion</em>
                                </code>
                              </td>
                              <td>
                                <div>
                                  <p>completion block.</p>

                                </div>
                              </td>
                            </tr>
                          </tbody>
                        </table>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:ZFC15testApplication14NetworkManager21postExchangeOperationFT12fromCurrencyOS_12CurrencyType9fromValueCSo15NSDecimalNumber10toCurrencyS1_7toValueS2_10completionGSqFGOS_13RequestResultSbOS0_19NetworkManagerError_T___T_"></a>
                    <a name="//apple_ref/swift/Method/postExchangeOperation(fromCurrency:fromValue:toCurrency:toValue:completion:)" class="dashAnchor"></a>
                    <a class="token" href="#/s:ZFC15testApplication14NetworkManager21postExchangeOperationFT12fromCurrencyOS_12CurrencyType9fromValueCSo15NSDecimalNumber10toCurrencyS1_7toValueS2_10completionGSqFGOS_13RequestResultSbOS0_19NetworkManagerError_T___T_">postExchangeOperation(fromCurrency:fromValue:toCurrency:toValue:completion:)</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Makes request for new exchange operation.
- parameter fromCurrency: source currency type.
- parameter fromValue: amount of source currency.
- parameter toCurrency: destination currency.
- parameter toValue: amount of destination currency.
- parameter completion: completion block.
- warning: this function just emulates the network request.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">class</span> <span class="kd">func</span> <span class="nf">postExchangeOperation</span><span class="p">(</span><span class="nv">fromCurrency</span><span class="p">:</span> <span class="kt"><a href="../Enums/CurrencyType.html">CurrencyType</a></span><span class="p">,</span> <span class="nv">fromValue</span><span class="p">:</span> <span class="kt">NSDecimalNumber</span><span class="p">,</span> <span class="nv">toCurrency</span><span class="p">:</span> <span class="kt"><a href="../Enums/CurrencyType.html">CurrencyType</a></span><span class="p">,</span> <span class="nv">toValue</span><span class="p">:</span> <span class="kt">NSDecimalNumber</span><span class="p">,</span> <span class="nv">completion</span><span class="p">:</span> <span class="p">((</span><span class="kt"><a href="../Classes/NetworkManager.html#/s:C15testApplication14NetworkManager27PostExchangeOperationResult">PostExchangeOperationResult</a></span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kt">Void</span><span class="p">)?</span> <span class="o">=</span> <span class="kc">nil</span><span class="p">)</span></code></pre>

                        </div>
                      </div>
                      <div>
                        <h4>Parameters</h4>
                        <table class="graybox">
                          <tbody>
                            <tr>
                              <td>
                                <code>
                                <em>fromCurrency</em>
                                </code>
                              </td>
                              <td>
                                <div>
                                  <p>source currency type.</p>

                                </div>
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <code>
                                <em>fromValue</em>
                                </code>
                              </td>
                              <td>
                                <div>
                                  <p>amount of source currency.</p>

                                </div>
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <code>
                                <em>toCurrency</em>
                                </code>
                              </td>
                              <td>
                                <div>
                                  <p>destination currency.</p>

                                </div>
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <code>
                                <em>toValue</em>
                                </code>
                              </td>
                              <td>
                                <div>
                                  <p>amount of destination currency.</p>

                                </div>
                              </td>
                            </tr>
                            <tr>
                              <td>
                                <code>
                                <em>completion</em>
                                </code>
                              </td>
                              <td>
                                <div>
                                  <p>completion block.</p>

                                </div>
                              </td>
                            </tr>
                          </tbody>
                        </table>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
          </section>
        </section>
        <section id="footer">
          <p>&copy; 2017 <a class="link" href="" target="_blank" rel="external"></a>. All rights reserved. (Last updated: 2017-01-05)</p>
          <p>Generated by <a class="link" href="https://github.com/realm/jazzy" target="_blank" rel="external">jazzy ♪♫ v0.7.3</a>, a <a class="link" href="http://realm.io" target="_blank" rel="external">Realm</a> project.</p>
        </section>
      </article>
    </div>
  </body>
</div>
</html>
